ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.7 by root, Sun Mar 11 20:37:04 2007 UTC vs.
Revision 1.90 by root, Tue Oct 5 23:52:02 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161our %WALL_SUFFIX = (
162 "0" => "⬤",
163 "1_3" => "╸",
164 "1_4" => "╺",
165 "2_1_2" => "━",
166
167 "1_2" => "╹",
168 "2_2_4" => "┛",
169 "2_2_1" => "┗",
170 "3_1" => "┻",
171
172 "1_1" => "╻",
173 "2_2_3" => "┓",
174 "2_2_2" => "┏",
175 "3_3" => "┳",
176
177 "2_1_1" => "┃",
178 "3_4" => "┫",
179 "3_2" => "┣",
180 "4" => "╋",
181);
182
183sub autoglyph {
184 my ($stem, $face) = @_;
185
186 if ($stem =~ /^wall\/|Nimwall/) {
187 while (my ($k, $v) = each %WALL_SUFFIX) {
188 return $v if $stem =~ /_$k.x11/;
189 }
190
191 "+"
192
193 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
194 "."
195
196 } elsif ($stem =~ /^player\//) {
197 "\@"
198
199 } else {
200 substr $stem, 0, 1
201 }
202}
203
82{ 204{
83 our %PNG32; 205 our %ANIMINFO;
84 our %FACEINFO; 206 our %FACEINFO;
207 our %RESOURCE;
85 our @ARC; 208 our @ARC;
209 our %ARC;
210 our $TRS;
86 our $NFILE; 211 our $NFILE;
87 our %ANIM; 212 our $PATH;
88 213
89 our (@png, @trs, @arc); # files we are interested in 214 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 215
216 our $c_arc = new Coro::Channel;
217 our $c_trs = new Coro::Channel;
218 our $c_res = new Coro::Channel;
219
220 our @c_png;
221
91 sub commit_png { 222 sub commit_png($$$$) {
92 my ($name, $data) = @_; 223 my ($stem, $name, $data, $T) = @_;
93 224
94 $PNG32{$name} = $data; 225 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 226 $FACEINFO{$name}{"data$T"} = $data;
96 } 227 }
97 228
98 sub process_png { 229 sub process_png {
99 while (@png) { 230 while (@c_png) {
100 my $path = pop @png; 231 my ($path, $delete) = @{pop @c_png};
101 232
102 my $png; 233 my $png;
103 aio_lstat $path; 234 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 235 my ($size, $mtime) = (stat _)[7,9];
105 236
106 if (0 > aio_load $path, $png) { 237 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 238 warn "$path: $!, skipping.\n";
108 next; 239 next;
109 } 240 }
110 241
242 my $stem = $path;
243 my $T;
244
245 if ($stem =~ s/\.32x32\.png~?$//) {
246 $T = 32;
247 } elsif ($stem =~ s/\.64x64\.png~?$//) {
248 $T = 64;
249 } else {
250 warn "$path: weird filename, skipping.\n";
251 next;
252 }
253
111 # quickly extract width and height of the (necessarily PNG) image 254 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 255 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 256 warn "$path: not a recognized png file, skipping.\n";
114 next; 257 next;
115 } 258 }
116 259
117 my ($w, $h) = unpack "NN", $1; 260 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 261
127 if ($w < $T || $h < $T) { 262 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 263 warn "$path: too small ($w $h), skipping.\n";
129 next; 264 next;
130 } 265 }
132 if ($w % $T || $h % $T) { 267 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 268 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 269 next;
135 } 270 }
136 271
272 (my $base = $stem) =~ s/^.*\///;
273
274 my $fi = $FACEINFO{$base};
275 unless ($fi) {
276 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
277 #next;
278 }
279
280 my $arc = $fi->{arc} || { };
281
282 unless ($path =~ /~$/) {
283 # possibly enlarge
284 if (0 > aio_stat "$stem.64x64.png") {
285 my $other = "$stem.64x64.png~";
286
287 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
288 fork_sub {
289 my $CROP;
290 my $SRC = "png:\Q$path\E";
291
292 my $is_floor = $arc->{is_floor};
293 my $is_wall = 0;
294
295 my ($wall_pfx, $wall_dir, $wall_sfx);
296
297 if (
298 !$is_floor
299 && !$arc->{alive}
300 && $arc->{move_block} eq "all"
301 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
302 ) {
303 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
304
305 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
306 $is_wall = 1;
307 }
308 }
309
310 if ($is_wall || $is_floor) {
311 # add a 4px border and add other images around it
312 $CROP = "-shave 8x8 +repage";
313
314 $w += 8;
315 $h += 8;
316
317 $SRC = "-size ${w}x${h} xc:transparent";
318 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
319
320 # 8 surrounding images
321 for (
322 # x y b r0 r1
323 [-1, -1, 0, 6],
324 [ 0, -1, 1, 10, 14],
325 [+1, -1, 0, 12],
326
327 [-1, 0, 8, 5, 7],
328 #
329 [+1, 0, 2, 5, 13],
330
331 [-1, +1, 0, 3],
332 [ 0, +1, 4, 10, 11],
333 [+1, +1, 0, 9],
334 ) {
335 my ($x, $y, $d, $r0, $r1) = @$_;
336
337 my $tile = $is_floor ? $path
338 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
339 : die;
340
341 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
342 "\Q$tile",
343 $x * ($w - 8) + 4,
344 $y * ($h - 8) + 4;
345 }
346 }
347
348 system "convert -depth 8 $SRC rgba:-"
349 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
350 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
351 and die "convert/cfhq2xa pipeline error: status $? ($!)";
352 system $OPTIPNG, "-i0", "-q", "$other~";
353 die "$other~ has zero size, aborting." unless -s "$other~";
354 rename "$other~", $other;
355 };
356 }
357
358 push @c_png, [$other, !$CACHE];
359 }
360
361 # possibly scale down
362 if (0 > aio_stat "$stem.32x32.png") {
363 my $other = "$stem.32x32.png~";
364
365 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
366 fork_sub {
367 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
368 system $OPTIPNG, "-i0", "-q", "$other~";
369
370 # reduce smoothfaces >10000 bytes
371 # obsolete, no longer required
372 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
373 my $ncolor = 256;
374 while () {
375 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
376 system $OPTIPNG, "-i0", "-q", "$other~~";
377 last if 10000 > -s "$other~~";
378 $ncolor = int $ncolor * 0.9;
379 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
380 }
381
382 printf "reduced %s from %d to %d bytes using %d colours.\n",
383 $other, -s "$other~", -s "$other~~", $ncolor
384 if $VERBOSE >= 2;
385 rename "$other~~", "$other~";
386 }
387
388 die "$other~ has zero size, aborting." unless -s "$other~";
389 rename "$other~", $other;
390 };
391 }
392
393 #warn "scaled down $path to $other\n";#d#
394 push @c_png, [$other, !$CACHE];
395 }
396 }
397
398 (my $face = $stem) =~ s/^.*\///;
399
400 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 401 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 402 # split
139 my @tile; 403 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 404 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 405 for my $y (0 .. (int $h / $T) - 1) {
155 ( 419 (
156 "(", 420 "(",
157 "+clone", 421 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 422 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 423 "+repage",
424 -quality => "00",
160 -write => "png:$_->[2]~", 425 -write => "png32:$_->[2]~",
161 "+delete", 426 "+delete",
162 ")", 427 ")",
163 ) 428 )
164 } @todo), 429 } @todo),
165 "null:"; 430 "null:";
169 close $convert; 434 close $convert;
170 435
171 # pass 2, optimise, and rename 436 # pass 2, optimise, and rename
172 for (@todo) { 437 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 438 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
439 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 440 rename "$_->[2]~", $_->[2];
175 } 441 }
176 }; 442 };
177 } 443 }
178 444
182 448
183 if (0 > aio_load $file, $tile) { 449 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 450 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 451 }
186 IO::AIO::aio_unlink $file unless $CACHE; 452 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 453 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 454 }
189 } else { 455 } else {
190 # use as-is (either small, use smooth) 456 # use as-is (either small, use smooth)
191 commit_png $face, $png; 457 commit_png $stem, $face, $png, $T;
192 } 458 }
459
460 aio_unlink $path if $delete;
193 } 461 }
194 } 462 }
195 463
196 sub process_arc { 464 sub process_arc {
197 while (@arc) { 465 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 466 my ($dir, $file) = @$job;
199 467
200 my $arc; 468 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 469 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 470
203 my $arc = read_arch "$dir/$file"; 471 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 472 for my $o (values %$arc) {
205 push @ARC, $o; 473 push @ARC, $o;
474 for (my $m = $o; $m; $m = $m->{more}) {
475 $ARC{$m->{_name}} = $m;
476 }
477
478 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
206 479
207 my $visibility = delete $o->{visibility}; 480 my $visibility = delete $o->{visibility};
208 my $magicmap = delete $o->{magicmap}; 481 my $magicmap = delete $o->{magicmap};
482 my $glyph = delete $o->{glyph};
209 483
210 # find upper left corner :/ 484 # find upper left corner :/
211 # omg, this is sooo broken 485 # omg, this is sooo broken
212 my ($dx, $dy); 486 my ($dx, $dy);
213 for (my $o = $o; $o; $o = $o->{more}) { 487 for (my $o = $o; $o; $o = $o->{more}) {
219 my $x = $o->{x} - $dx; 493 my $x = $o->{x} - $dx;
220 my $y = $o->{y} - $dy; 494 my $y = $o->{y} - $dy;
221 495
222 my $ext = $x|$y ? "+$x+$y" : ""; 496 my $ext = $x|$y ? "+$x+$y" : "";
223 497
224 $o->{face} .= $ext; 498 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
225 499
226 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 500 $visibility = delete $o->{visibility} if exists $o->{visibility};
227 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 501 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
502 $glyph = delete $o->{glyph} if exists $o->{glyph};
228 503
229 my $anim = delete $o->{anim}; 504 my $anim = delete $o->{anim};
230 505
231 if ($anim) { 506 if ($anim) {
507 # possibly add $ext to the animation name to avoid
508 # the need to specify archnames for all parts
509 # of a multipart archetype.
232 $o->{animation} = "$o->{_name}$ext"; 510 $o->{animation} = "$o->{_name}";
511 my $facings = 1;
512 my @frames;
233 513
234 for (@$anim) { 514 for (@$anim) {
235 $_ .= $ext unless /^facings\s/; 515 if (/^facings\s+(\d+)/) {
516 $facings = $1*1;
517 } elsif (/^blank.x11$|^empty.x11$/) {
518 push @frames, $_;
519 } else {
520 push @frames, "$_$ext";
521 }
236 } 522 }
237 523
238 $ANIM{"$o->{_name}$ext"} = 524 $ANIMINFO{$o->{animation}} = {
239 join "", map "$_\n", 525 facings => $facings,
240 "anim $o->{_name}$ext", 526 frames => \@frames,
241 @$anim, 527 };
242 "mina";
243 } 528 }
244 529
245 for my $face ($o->{face} || (), @{$anim || []}) { 530 for ($o->{face} || (), @{$anim || []}) {
246 next if /^facings\s/; 531 next if /^facings\s/;
247 532
533 my $face = $_;
534 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
535
248 my $info = $FACEINFO{$face} ||= {}; 536 my $info = $FACEINFO{$face} ||= { };
537 $info->{arc} = $o;
538
539 next if $face =~ /^blank.x11$|^empty.x11$/;
249 540
250 $info->{visibility} = $visibility if defined $visibility; 541 $info->{visibility} = $visibility if defined $visibility;
251 $info->{magicmap} = $magicmap if defined $magicmap; 542 $info->{magicmap} = $magicmap if defined $magicmap;
543 $info->{glyph} = $glyph if defined $glyph;
252 } 544 }
545
546 if (my $smooth = delete $o->{smoothface}) {
547 my %kv = split /\s+/, $smooth;
548 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
549 while (my ($face, $smooth) = each %kv) {
550 $FACEINFO{$smooth}{arc} = $o;
551
552 $FACEINFO{$face}{smooth} = $smooth;
553 $FACEINFO{$face}{smoothlevel} = $level;
554 }
555 }
253 } 556 }
254 } 557 }
255 } 558 }
256 } 559 }
257 560
258 sub process_trs { 561 sub process_trs {
259 while (@trs) { 562 while (my $job = $c_trs->get) {
260 my ($dir, $file) = @{pop @trs}; 563 my ($dir, $file) = @$job;
564 my $path = "$dir/$file";
565
566 my $trs;
567 if (0 > aio_load $path, $trs) {
568 warn "$path: $!, skipping.\n";
569 next;
570 }
571
572 $TRS .= $trs;
573 }
574 }
575
576 my %FILECACHE;
577
578 sub load_cached($;$) {
579 unless (exists $FILECACHE{$_[0]}) {
580 my $data;
581 if (0 < aio_load $_[0], $data) {
582 if ($_[1]) {
583 $data = eval { $_[1]->($data) };
584 warn "$_[0]: $@" if $@;
585 }
586 }
587
588 $FILECACHE{$_[0]} = $data;
589 }
590
591 $FILECACHE{$_[0]}
592 }
593
594 sub process_res {
595 while (my $job = $c_res->get) {
596 my ($dir, $file, $type) = @$job;
597
598 my $data;
599 aio_load "$dir/$file", $data;
600
601 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
602
603 utf8::decode $dir;
604 utf8::decode $file;
605
606 # a meta file for resources is now mandatory
607 unless (exists $meta->{$file}) {
608 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
609 next;
610 }
611
612 $meta = {
613 %{ $meta->{"" } || {} },
614 %{ $meta->{$file} || {} },
615 };
616
617 if ($meta->{license} =~ s/^#//) {
618 $meta->{license} = ({
619 "pd" => "Public Domain",
620 "gpl" => "GNU General Public License, version 3.0 or any later",
621 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
622 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
623 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
624 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
625 })->{$meta->{license}}
626 || warn "$dir/$file: license tag '$meta->{license}' not found.";
627 }
628
629 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
630 ($meta->{author} = $1) =~ s/_/ /g;
631 }
632
633 $file =~ s/\.res$//;
634 $file =~ s/\.(ogg|wav|jpg|png)$//;
635
636 substr $dir, 0, 1 + length $PATH, "";
637
638 if (my $filter = $meta->{cfutil_filter}) {
639 if ($filter eq "yaml2json") {
640 $data = JSON::XS::encode_json YAML::XS::Load $data;
641 } elsif ($filter eq "json2json") {
642 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
643 } elsif ($filter eq "perl2json") {
644 $data = eval $data; die if $@;
645 $data = JSON::XS::encode_json $data;
646 } else {
647 warn "$dir/$file: unknown filter $filter, skipping\n";
648 }
649 }
650
651 $RESOURCE{"$dir/$file"} = {
652 type => (exists $meta->{type} ? delete $meta->{type} : $type),
653 data => $data,
654 %$meta ? (meta => $meta) : (),
655 };
261 } 656 }
262 } 657 }
263 658
264 sub find_files; 659 sub find_files;
265 sub find_files { 660 sub find_files {
268 IO::AIO::aioreq_pri 4; 663 IO::AIO::aioreq_pri 4;
269 IO::AIO::aio_scandir $path, 4, sub { 664 IO::AIO::aio_scandir $path, 4, sub {
270 my ($dirs, $nondirs) = @_; 665 my ($dirs, $nondirs) = @_;
271 666
272 find_files "$path/$_" 667 find_files "$path/$_"
273 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 668 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
669
670 my $dir = $path;
671 substr $dir, 0, 1 + length $PATH, "";
274 672
275 for my $file (@$nondirs) { 673 for my $file (@$nondirs) {
674 if ($dir =~ /^music(?:\/|$)/) {
675 $c_res->put ([$path, $file, 3]) # FT_MUSIC
676 if $file =~ /\.(ogg)$/;
677
678 } elsif ($dir =~ /^sound(?:\/|$)/) {
679 $c_res->put ([$path, $file, 5]) # FT_SOUND
680 if $file =~ /\.(wav|ogg)$/;
681
682 } elsif ($dir =~ /^res(?:\/|$)/) {
683 if ($file =~ /\.(jpg|png)$/) {
684 $c_res->put ([$path, $file, 0]) # FT_FACE
685 } elsif ($file =~ /\.(res)$/) {
686 $c_res->put ([$path, $file, 6]) # FT_RSRC
687 } else {
688 $c_res->put ([$path, $file, undef]);
689 }
690
276 if ($file =~ /\.png$/) { 691 } elsif ($file =~ /\.png$/) {
277 push @png, "$path/$file"; 692 push @c_png, ["$path/$file", 0];
693
278 } elsif ($file =~ /\.trs$/) { 694 } elsif ($file =~ /\.trs$/) {
279 push @trs, [$path, $file]; 695 $c_trs->put ([$path, $file]);
696
280 } elsif ($file =~ /\.arc$/) { 697 } elsif ($file =~ /\.arc$/) {
281 push @arc, [$path, $file]; 698 $c_arc->put ([$path, $file]);
699
282 } else { 700 } else {
283 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 701 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
284 } 702 }
285 } 703 }
286 }; 704 };
705 }
706
707 sub generate_plurals {
708# use Lingua::EN::Inflect ();
709# Lingua::EN::Inflect::classical;
710# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
711# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
712#
713# for my $a (@ARC) {
714# my $name = $a->{name} || $a->{_name};
715#
716# next unless $a->{name_pl};
717# next if $a->{invisible};
718# next if $a->{is_floor};
719# next if $a->{no_pick};
720#
721# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
722# my $pl = $test =~ /^(?:eq|p:.)$/
723# ? $name
724# : Lingua::EN::Inflect::PL $name;
725#
726# if ($pl ne $a->{name_pl}) {
727# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
728# }
729# }
287 } 730 }
288 731
289 sub inst_arch($) { 732 sub inst_arch($) {
290 my (undef, $path) = @_; 733 my (undef, $path) = @_;
291 734
735 $PATH = $path;
736
737 print "\n",
292 print "installing '$path' to '$DATADIR'\n\n"; 738 "Installing '$path' to '$DATADIR'\n",
739 "\n",
740 "This can take a long time if you run this\n",
741 "for the first time or do not use --cache.\n",
742 "\n",
743 "Unless you run verbosely, all following warning\n",
744 "or error messages indicate serious problems.\n",
745 "\n";
293 746
294 if (!-d "$path/treasures") { 747 if (!-d "$path/treasures") {
295 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 748 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
296 exit 1 unless $FORCE; 749 exit 1 unless $FORCE;
297 } 750 }
298 751
752 print "scanning files...\n" if $VERBOSE;
753
299 find_files $path; 754 find_files $path;
755
756 my @a_arc = map +(async \&process_arc), 1..2;
757 my @a_res = map +(async \&process_res), 1..2;
758 my @a_trs = map +(async \&process_trs), 1..2;
759
300 IO::AIO::flush; 760 IO::AIO::flush;
301 761
302 $_->join for ( 762 $c_res->shutdown;
303 (async \&process_png), (async \&process_png), 763 $c_arc->shutdown;
304 (async \&process_trs), (async \&process_trs), 764 $c_trs->shutdown;
305 (async \&process_arc), (async \&process_arc),
306 );
307 765
766 print "start file scan, arc, res processing...\n" if $VERBOSE;
767
768 $_->join for @a_arc; # need to parse all archetypes before png processing
769
770 print "end arc, start png processing...\n" if $VERBOSE;
771
772 # eight png crunchers work fine for my 4x smp machine
773 my @a_png = map +(async \&process_png), 1..8;
774
775 $_->join for (@a_trs, @a_res, @a_png);
776
777 print "scanning done, processing results...\n" if $VERBOSE;
308 { 778 {
309 open my $fh, ">:utf8", "$DATADIR/animations~" 779 # remove path prefix from editor_folder
310 or die "$DATADIR/animations~: $!"; 780 $_->{editor_folder} =~ /^\x00/
311 print $fh join "", map $ANIM{$_}, sort keys %ANIM 781 and substr $_->{editor_folder}, 0, 2 + length $path, ""
782 for values %ARC;
783
784 print "resolving inheritance tree...\n" if $VERBOSE;
785 # resolve inherit
786 while () {
787 my $progress;
788 my $loop;
789
790 for my $o (values %ARC) {
791 for my $other (split /,/, $o->{inherit}) {
792 if (my $s = $ARC{$other}) {
793 if ($s->{inherit}) {
794 $loop = $s;
795 } else {
796 delete $o->{inherit};
797 my %s = %$s;
798 delete @s{qw(_name more name name_pl)};
799 %$o = ( %s, %$o );
800 ++$progress;
801 }
802 } else {
803 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
804 delete $ARC{$o->{_name}};
805 }
806 }
807 }
808
809 unless ($progress) {
810 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
811 if $loop;
812
813 last;
814 }
312 } 815 }
313 816
314 { 817 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
818 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
819
820 print "generating plurals...\n" if $VERBOSE;
821 generate_plurals;
822
823 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
315 open my $fh, ">:utf8", "$DATADIR/archetypes~" 824 open my $fh, ">:utf8", "$DATADIR/archetypes~"
316 or die "$DATADIR/archetypes~: $!"; 825 or die "$DATADIR/archetypes~: $!";
317 print $fh Crossfire::archlist_to_string \@ARC; 826 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
318 } 827 }
319 828
320 { 829 {
830 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
831 open my $fh, ">:utf8", "$DATADIR/treasures~"
832 or die "$DATADIR/treasures~: $!";
833 print $fh $TRS;
834 }
835
836 {
837 print "processing facedata...\n" if $VERBOSE;
321 while (my ($k, $v) = each %FACEINFO) { 838 while (my ($k, $v) = each %FACEINFO) {
322 $v->{data32} ||= delete $PNG32{$k}; 839 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
840 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
841
842 make_hash $k, $v->{data32}, $v->{hash32};
843 make_hash $k, $v->{data64}, $v->{hash64};
844
845 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
846 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
847
848 my $stem = delete $v->{stem};
849 $v->{glyph} //= autoglyph $stem, $v;
850
851 if (my $magicmap = $v->{magicmap}) {
852 $magicmap =~ y/A-Z_\-/a-z/d;
853 $v->{magicmap} = $COLOR{$magicmap};
323 } 854 }
324 855
856 delete $v->{arc};
857 }
858
859 print "processing resources...\n" if $VERBOSE;
860 my $enc = JSON::XS->new->utf8->canonical->relaxed;
325 while (my ($k, $v) = each %FACEINFO) { 861 while (my ($k, $v) = each %RESOURCE) {
326 exists $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
327 862
328 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 863 if ($v->{meta} && $v->{meta}{datadir}) {
864 delete $RESOURCE{$k};
865
866 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
867
868 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
869 open my $fh, ">:raw", "$DATADIR/$k~"
870 or die "$DATADIR/$k~: $!";
871 syswrite $fh, $v->{data};
872 push @COMMIT, $k;
873
874 } else {
875 if ($v->{type} & 1) {
876 # prepend meta info
877
878 my $meta = $enc->encode ({
879 name => $k,
880 %{ $v->{meta} || {} },
881 });
882
883 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
884 }
885
886 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
329 } 887 }
888 }
330 889
890 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
891 scalar keys %FACEINFO,
892 scalar keys %ANIMINFO,
893 scalar keys %RESOURCE
894 if $VERBOSE;
895
331 open my $fh, ">:perlio", "$DATADIR/faces~" 896 open my $fh, ">:perlio", "$DATADIR/facedata~"
332 or die "$DATADIR/faces~: $!"; 897 or die "$DATADIR/facedata~: $!";
333 898
334 print $fh Storable::nfreeze \%FACEINFO; 899 print $fh nfreeze {
335 900 version => 2,
336 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 901 faceinfo => \%FACEINFO,
902 animinfo => \%ANIMINFO,
903 resource => \%RESOURCE,
337 } 904 };
338 905
339 for (qw(archetypes faces animations)) { 906 }
907
908 print "committing files...\n" if $VERBOSE;
909
910 for (qw(archetypes facedata treasures), @COMMIT) {
340 chmod 0644, "$DATADIR/$_~"; 911 chmod 0644, "$DATADIR/$_~";
341 rename "$DATADIR/$_~", "$DATADIR/$_"; 912 rename "$DATADIR/$_~", "$DATADIR/$_"
913 or die "$DATADIR/$_: $!";
342 } 914 }
343 915
344 die "--install-arch not fully implemented\n"; 916 print "archetype data installed successfully.\n";
345 } 917 }
346} 918}
347 919
348Getopt::Long::Configure ("bundling", "no_ignore_case"); 920Getopt::Long::Configure ("bundling", "no_ignore_case");
349GetOptions ( 921GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines